org.optaplanner.core.impl.score.director

## Interface InnerScoreDirectorFactory<Solution_>

- Type Parameters:
    `Solution_` - the solution type, the class with the `PlanningSolution` annotation
  All Superinterfaces:
    ScoreDirectorFactory<Solution_>
  All Known Implementing Classes:
    AbstractScoreDirectorFactory, ConstraintStreamScoreDirectorFactory, DroolsScoreDirectorFactory, EasyScoreDirectorFactory, IncrementalScoreDirectorFactory, LegacyDroolsScoreDirectorFactory, TestGenDroolsScoreDirectorFactory, TestGenLegacyDroolsScoreDirectorFactory

      public interface InnerScoreDirectorFactory<Solution_>
      extends ScoreDirectorFactory<Solution_>

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `assertScoreFromScratch(Solution_ solution)` Asserts that if the `Score` is calculated for the parameter solution, it would be equal to the score of that parameter.
    `InnerScoreDirector<Solution_>` | `buildScoreDirector()` Creates a new `ScoreDirector` instance.
    `InnerScoreDirector<Solution_>` | `buildScoreDirector(boolean lookUpEnabled, boolean constraintMatchEnabledPreference)` Like `buildScoreDirector()`, but optionally disables `ConstraintMatch` tracking and look up for more performance (presuming the `ScoreDirector` implementation actually supports it to begin with).
    `InitializingScoreTrend` | `getInitializingScoreTrend()`
    `ScoreDefinition` | `getScoreDefinition()`
    `SolutionDescriptor<Solution_>` | `getSolutionDescriptor()`

- - ### Method Detail

    - #### getSolutionDescriptor

          SolutionDescriptor<Solution_> getSolutionDescriptor()

      Returns:
        never null

    - #### getScoreDefinition

          ScoreDefinition getScoreDefinition()

      Returns:
        never null

    - #### buildScoreDirector

          InnerScoreDirector<Solution_> buildScoreDirector()

      Description copied from interface: `ScoreDirectorFactory`
      Creates a new `ScoreDirector` instance.
      Specified by:
        `buildScoreDirector` in interface `ScoreDirectorFactory<Solution_>`
      Returns:
        never null

    - #### buildScoreDirector

          InnerScoreDirector<Solution_> buildScoreDirector(boolean lookUpEnabled,
                                                           boolean constraintMatchEnabledPreference)

      Like `buildScoreDirector()`, but optionally disables `ConstraintMatch` tracking and look up for more performance (presuming the `ScoreDirector` implementation actually supports it to begin with).
      Parameters:
        `lookUpEnabled` - true if a `ScoreDirector` implementation should track all working objects for `ScoreDirector.lookUpWorkingObject(Object)`
        `constraintMatchEnabledPreference` - false if a `ScoreDirector` implementation should not do `ConstraintMatch` tracking even if it supports it.
      Returns:
        never null
      See Also:
        `ScoreDirector.isConstraintMatchEnabled()`, `ScoreDirector.getConstraintMatchTotalMap()`

    - #### getInitializingScoreTrend

          InitializingScoreTrend getInitializingScoreTrend()

      Returns:
        never null

    - #### assertScoreFromScratch

          void assertScoreFromScratch(Solution_ solution)

      Asserts that if the `Score` is calculated for the parameter solution, it would be equal to the score of that parameter.
      Parameters:
        `solution` - never null
      See Also:
        `InnerScoreDirector.assertWorkingScoreFromScratch(Score, Object)`

Copyright © 2006–2020 JBoss by Red Hat. All rights reserved.